import sys
import codecs

#avtor: Rok Kaufman (& Vid Kocijan)
#v programu so funkcije, ki jih je potrebno zaganjati iz komandne vrstice. za pravilno branje datotek je OBVEZNO potrebno branje v UTF-8 kodiranju!

abc="abcčdefghijklmnoprsštuvzžABCČDEFGHIJKLMNOPRSŠTUVZŽ"
abc_freq=[0.10466, 0.01939, 0.00662, 0.01483, 0.03390, 0.10707, 0.00110, 0.01638, 0.01047, 0.09042, 0.04675, 0.03704, 0.05266, 0.03305, 0.06328, 0.09084, 0.03374, 0.05010, 0.05053, 0.00996, 0.04329, 0.01879, 0.03764, 0.02103, 0.00646]

def desifr(kljuc, besedilo):
  output=""
  besedilo=samocrke(besedilo)
  for i in range(len(besedilo)):
    output += abc[((abc.index(besedilo[i]))-(abc.index(kljuc[i%(len(kljuc))])))%25]
  return(output)
  
def sifr(kljuc, besedilo):
  output=""
  besedilo=samocrke(besedilo)
  for i in range(len(besedilo)):
    output += abc[((abc.index(besedilo[i]))+(abc.index(kljuc[i%(len(kljuc))])))%25]
  return(output)

def freq(a):
  crke=[0]*25
  for i in range(len(a)):
    if a[i] in abc:
      crke[abc.index(a[i])%25]+=1
  return crke    

def IC(a):
  ic=0.0
  for i in range(25):
    ic=ic+(a[i]*(a[i]-1))/(sum(a)*(sum(a)-1))
  return ic
  
def M(g, besedilo):
  m=0.0
  for i in range(25):
    m=m+(abc_freq[i]*(freq(besedilo))[(i+g)%25])
  return m 
  
def samocrke(besedilo):
  output=""
  for i in range(len(besedilo)):
    if besedilo[i] in abc:
      output += besedilo[i]
  return(output)    

def zlomi(text):
  samocrke(text)
  ic_vrednost=[0.0]*(int(len(text)**0.5))
  for i in range(1, int(len(text)**0.5)+1):
    subtext=["" for j in range(i)]
    for j in range(len(text)):
      subtext[j%i]=subtext[j%i]+text[j]
    for j in range(i):
      ic_vrednost[i-1]=ic_vrednost[i-1]+IC(freq(subtext[j]))
    ic_vrednost[i-1]=ic_vrednost[i-1]/i
    print(i, ic_vrednost[i-1])
  print()
  l=0
  i=0
  while i in range(int(len(text)**0.5)):
    if ic_vrednost[i]>0.056:
      l=i+1
      i=-2
    i+=1
  print("dolžina ključa:", l)
  print()
  subtext=["" for j in range(l)]
  for j in range(len(text)):
    subtext[j%l]=subtext[j%l]+text[j]
  geslo=""
  for j in range(l):
    m_vrednosti=[0]*25
    for g in range(25):
      m_vrednosti[g]=M(g,subtext[j])
    geslo=geslo+abc[m_vrednosti.index(max(m_vrednosti))]
  print("Ključ:",geslo)
  return(desifr(geslo,text))
      
  
  
  
